import json
import sys
from functools import partial
import ffmpeg
from datasets import  Dataset, Audio, DatasetDict
from pathlib import Path
import re

#ffmpeg -i 59452.ogg -af "silenceremove=start_periods=1:start_silence=0.2:start_threshold=-60dB,areverse,silenceremove=start_periods=1:start_silence=0.2:start_threshold=-60dB,areverse" -ar 24000 out.wav
#input_file = Path(sys.argv[1])
#output_file = input_file.with_suffix('.txt')
#wav_path = input_file.stem
splits = ['kateryna', 'lada', 'mykyta', 'oleksa', 'tetiana']

def gen_split(name):
    input_file = name+'.jsonl'
    #output_file = name+'.txt'
    with open(input_file, 'r') as jsonl:#, open(output_file, 'w') as new_format:
        for line in jsonl:
            line = json.loads(line)
            afile = Path(f'{name}/{line["audio"]}')
            wav_file = str(afile.with_suffix('.wav'))
            stream = ffmpeg.input(afile)
            ft = "silenceremove=start_periods=1:start_silence=0.1:start_threshold=-50dB,areverse,atrim=1,silenceremove=start_periods=1:start_silence=0.155555:start_threshold=-50dB,areverse"
            stream = ffmpeg.output(stream, wav_file, af=ft)
            ffmpeg.run(stream)
            #stream = ffmpeg.input(wav_file)
            #stream = ffmpeg.output(stream, wav_file, -af="areverse,atrim=4,areverse" )
            #ffmpeg.run(stream)
            #new_format.write(f'{str(afile.with_suffix(".wav"))}|{sys.argv[2]}|{line["text_stressed"]}\n')
            line['id'] = re.match('(\d+)\.ogg', line['audio']).group(1)
            line['audio'] = str(afile.with_suffix(".wav"))
            try:
                probe = ffmpeg.probe(line['audio'])
                line['duration'] = float(probe["format"]["duration"])
            except:
                print(line['audio'])
                continue
            yield line
dataset = DatasetDict()
for split in splits:
    dataset[split] = Dataset.from_generator(partial(gen_split, split)).cast_column("audio", Audio())

dataset.push_to_hub("patriotyk/opentts-uk")





